blob: a453f22e2935461bbeabf6c7f1c478c673caae20 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leung0afa07a2017-10-03 16:56:30 -070048export USE_D8="false"
Colin Crosse0ef0a82017-07-27 21:29:18 +000049export USE_JACK="false"
Igor Murashkin2a337752017-06-16 14:34:40 +000050export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070051export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070052
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070053# If dx was not set by the environment variable, assume it is in the path.
54if [ -z "$DX" ]; then
55 export DX="dx"
56fi
57
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080058# If jasmin was not set by the environment variable, assume it is in the path.
59if [ -z "$JASMIN" ]; then
60 export JASMIN="jasmin"
61fi
62
Andreas Gampe8fda9f22014-10-03 16:15:37 -070063# If smali was not set by the environment variable, assume it is in the path.
64if [ -z "$SMALI" ]; then
65 export SMALI="smali"
66fi
67
68# If dexmerger was not set by the environment variable, assume it is in the path.
69if [ -z "$DXMERGER" ]; then
70 export DXMERGER="dexmerger"
71fi
72
Sebastien Hertz19ac0272015-02-24 17:39:50 +010073# If jack was not set by the environment variable, assume it is in the path.
74if [ -z "$JACK" ]; then
75 export JACK="jack"
76fi
77
Sebastien Hertz19ac0272015-02-24 17:39:50 +010078# ANDROID_BUILD_TOP is not set in a build environment.
79if [ -z "$ANDROID_BUILD_TOP" ]; then
80 export ANDROID_BUILD_TOP=$oldwd
81fi
82
Andreas Gampef47fb2f2016-06-24 22:30:29 -070083# ANDROID_HOST_OUT is not set in a build environment.
84if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080085 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086fi
87
Sebastien Hertz19ac0272015-02-24 17:39:50 +010088# If JACK_CLASSPATH is not set, assume it only contains core-libart.
89if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070090 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091fi
92
Sebastien Hertz19ac0272015-02-24 17:39:50 +010093export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080094
Igor Murashkine5181932017-06-15 16:03:50 -070095# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070096if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070097 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
98fi
99
Igor Murashkin271a0f82017-02-14 21:14:17 +0000100# Zipalign is not on the PATH in some configs, auto-detect it.
101if [ -z "$ZIPALIGN" ]; then
102 if which zipalign >/dev/null; then
103 ZIPALIGN="zipalign";
104 else
105 # TODO: Add a dependency for zipalign in Android.run-test.mk
106 # once it doesn't depend on libandroidfw (b/35246701)
107 case "$OSTYPE" in
108 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
109 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
110 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
111 esac
112 fi
113fi
114export ZIPALIGN
115
David Brazdil122c6632018-01-24 17:32:49 +0000116# If hiddenapi was not set by the environment variable, assume it is in
117# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000118if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000119 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000120fi
121
jeffhao5d1ac922011-09-29 17:41:15 -0700122info="info.txt"
123build="build"
124run="run"
125expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700126check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700127output="output.txt"
128build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100129cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700130strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700131lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700132testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700133run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000134build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700135
Alex Light91de25f2015-10-28 17:00:06 -0700136quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000137debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700138prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700139target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700140dev_mode="no"
141update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700142debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000143relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800144runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700145usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700146build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700147suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700148trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700149trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700150basic_verify="false"
151gc_verify="false"
152gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700153jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700154jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700155jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700156jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700157strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700158always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700159never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700160have_dex2oat="yes"
161have_patchoat="yes"
162have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800163multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000164android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700165bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800166suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700167# By default we will use optimizing.
168image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000169image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700170
171while true; do
172 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700173 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700174 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100175 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700176 shift
Alex Light91de25f2015-10-28 17:00:06 -0700177 elif [ "x$1" = "x--quiet" ]; then
178 quiet="yes"
179 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700180 elif [ "x$1" = "x--use-java-home" ]; then
181 if [ -n "${JAVA_HOME}" ]; then
182 export JAVA="${JAVA_HOME}/bin/java"
183 export JAVAC="${JAVA_HOME}/bin/javac -g"
184 else
185 echo "Passed --use-java-home without JAVA_HOME variable set!"
186 usage="yes"
187 fi
188 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800189 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700190 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800191 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800192 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700193 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700194 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700195 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100196 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100197 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700198 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700199 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800200 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700201 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700202 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700203 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700204 shift
205 elif [ "x$1" = "x--dalvik" ]; then
206 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800207 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700208 shift
Alex Light03a112d2014-08-25 13:25:56 -0700209 elif [ "x$1" = "x--no-dex2oat" ]; then
210 have_dex2oat="no"
211 shift
212 elif [ "x$1" = "x--no-patchoat" ]; then
213 have_patchoat="no"
214 shift
215 elif [ "x$1" = "x--no-image" ]; then
216 have_image="no"
217 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800218 elif [ "x$1" = "x--multi-image" ]; then
219 multi_image_suffix="-multi"
220 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700221 elif [ "x$1" = "x--pic-test" ]; then
222 run_args="${run_args} --pic-test"
223 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700224 elif [ "x$1" = "x--relocate" ]; then
225 relocate="yes"
226 shift
227 elif [ "x$1" = "x--no-relocate" ]; then
228 relocate="no"
229 shift
230 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100231 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700232 prebuild_mode="yes"
233 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800234 elif [ "x$1" = "x--compact-dex-level" ]; then
235 option="$1"
236 shift
237 run_args="${run_args} $option $1"
238 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700239 elif [ "x$1" = "x--strip-dex" ]; then
240 run_args="${run_args} --strip-dex"
241 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000242 elif [ "x$1" = "x--debuggable" ]; then
243 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000244 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000245 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700246 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100247 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700248 prebuild_mode="no"
249 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700250 elif [ "x$1" = "x--gcverify" ]; then
251 basic_verify="true"
252 gc_verify="true"
253 shift
254 elif [ "x$1" = "x--gcstress" ]; then
255 basic_verify="true"
256 gc_stress="true"
257 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700258 elif [ "x$1" = "x--jvmti-step-stress" ]; then
259 jvmti_step_stress="true"
260 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700261 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
262 jvmti_redefine_stress="true"
263 shift
Alex Light43e935d2017-06-19 15:40:40 -0700264 elif [ "x$1" = "x--jvmti-field-stress" ]; then
265 jvmti_field_stress="true"
266 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700267 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
268 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700269 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800270 elif [ "x$1" = "x--suspend-timeout" ]; then
271 shift
272 suspend_timeout="$1"
273 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700274 elif [ "x$1" = "x--image" ]; then
275 shift
276 image="$1"
277 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700278 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000279 elif [ "x$1" = "x-Xcompiler-option" ]; then
280 shift
281 option="$1"
282 run_args="${run_args} -Xcompiler-option $option"
283 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000284 elif [ "x$1" = "x--build-option" ]; then
285 shift
286 option="$1"
287 build_args="${build_args} $option"
288 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700289 elif [ "x$1" = "x--runtime-option" ]; then
290 shift
291 option="$1"
292 run_args="${run_args} --runtime-option $option"
293 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700294 elif [ "x$1" = "x--gdb-arg" ]; then
295 shift
296 gdb_arg="$1"
297 run_args="${run_args} --gdb-arg $gdb_arg"
298 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700299 elif [ "x$1" = "x--debug" ]; then
300 run_args="${run_args} --debug"
301 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700302 elif [ "x$1" = "x--debug-wrap-agent" ]; then
303 run_args="${run_args} --debug-wrap-agent"
304 shift
Alex Light0e151e72017-10-25 10:50:35 -0700305 elif [ "x$1" = "x--with-agent" ]; then
306 shift
307 option="$1"
308 run_args="${run_args} --with-agent $1"
309 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700310 elif [ "x$1" = "x--debug-agent" ]; then
311 shift
312 option="$1"
313 run_args="${run_args} --debug-agent $1"
314 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700315 elif [ "x$1" = "x--gdb" ]; then
316 run_args="${run_args} --gdb"
317 dev_mode="yes"
318 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700319 elif [ "x$1" = "x--strace" ]; then
320 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700321 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700322 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700323 elif [ "x$1" = "x--zygote" ]; then
324 run_args="${run_args} --zygote"
325 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800326 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000327 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700328 image_suffix="-interpreter"
329 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800330 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700331 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000332 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800333 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700334 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700335 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800336 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700337 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700338 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700339 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700340 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700341 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700342 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700343 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700344 elif [ "x$1" = "x--no-optimize" ]; then
345 run_args="${run_args} --no-optimize"
346 shift
347 elif [ "x$1" = "x--no-precise" ]; then
348 run_args="${run_args} --no-precise"
349 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700350 elif [ "x$1" = "x--invoke-with" ]; then
351 shift
352 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700353 if [ "x$what" = "x" ]; then
354 echo "$0 missing argument to --invoke-with" 1>&2
355 usage="yes"
356 break
357 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700358 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700359 shift
360 elif [ "x$1" = "x--dev" ]; then
361 run_args="${run_args} --dev"
362 dev_mode="yes"
363 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700364 elif [ "x$1" = "x--build-only" ]; then
365 build_only="yes"
366 shift
Alan Leung0afa07a2017-10-03 16:56:30 -0700367 elif [ "x$1" = "x--build-with-d8" ]; then
368 USE_D8="true"
369 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100370 elif [ "x$1" = "x--build-with-javac-dx" ]; then
371 USE_JACK="false"
372 shift
373 elif [ "x$1" = "x--build-with-jack" ]; then
374 USE_JACK="true"
375 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700376 elif [ "x$1" = "x--output-path" ]; then
377 shift
378 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700379 if [ "x$tmp_dir" = "x" ]; then
380 echo "$0 missing argument to --output-path" 1>&2
381 usage="yes"
382 break
383 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700384 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000385 elif [ "x$1" = "x--android-root" ]; then
386 shift
387 if [ "x$1" = "x" ]; then
388 echo "$0 missing argument to --android-root" 1>&2
389 usage="yes"
390 break
391 fi
392 android_root="$1"
393 run_args="${run_args} --android-root $1"
394 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700395 elif [ "x$1" = "x--update" ]; then
396 update_mode="yes"
397 shift
398 elif [ "x$1" = "x--help" ]; then
399 usage="yes"
400 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700401 elif [ "x$1" = "x--64" ]; then
402 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700403 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700404 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200405 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700406 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200407 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700408 elif [ "x$1" = "x--stream" ]; then
409 trace_stream="true"
410 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700411 elif [ "x$1" = "x--always-clean" ]; then
412 always_clean="yes"
413 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700414 elif [ "x$1" = "x--never-clean" ]; then
415 never_clean="yes"
416 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800417 elif [ "x$1" = "x--dex2oat-swap" ]; then
418 run_args="${run_args} --dex2oat-swap"
419 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700420 elif [ "x$1" = "x--instruction-set-features" ]; then
421 shift
422 run_args="${run_args} --instruction-set-features $1"
423 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700424 elif [ "x$1" = "x--bisection-search" ]; then
425 bisection_search="yes"
426 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000427 elif [ "x$1" = "x--vdex" ]; then
428 run_args="${run_args} --vdex"
429 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000430 elif [ "x$1" = "x--vdex-filter" ]; then
431 shift
432 filter=$1
433 run_args="${run_args} --vdex-filter $filter"
434 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700435 elif [ "x$1" = "x--random-profile" ]; then
436 run_args="${run_args} --random-profile"
437 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700438 elif [ "x$1" = "x--dex2oat-jobs" ]; then
439 shift
440 run_args="${run_args} -Xcompiler-option -j$1"
441 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700442 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700443 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700444 usage="yes"
445 break
446 else
447 break
448 fi
449done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700450
Alex Light10bc5a42016-05-10 10:01:22 -0700451run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700452# Allocate file descriptor real_stderr and redirect it to the shell's error
453# output (fd 2).
454if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
455 exec {real_stderr}>&2
456else
457 # In bash before version 4.1 we need to do a manual search for free file
458 # descriptors.
459 FD=3
460 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
461 real_stderr=$FD
462 eval "exec ${real_stderr}>&2"
463fi
464if [ "$quiet" = "yes" ]; then
465 # Force the default standard output and error to go to /dev/null so we will
466 # not print them.
467 exec 1>/dev/null
468 exec 2>/dev/null
469fi
470
471function err_echo() {
472 echo "$@" 1>&${real_stderr}
473}
474
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700475# tmp_dir may be relative, resolve.
476#
477# Cannot use realpath, as it does not exist on Mac.
478# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700479# Cannot use readlink -m, as it does not exist on Mac.
480# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700481noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700482tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700483mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700484
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800485# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000486if [ ! "$runtime" = "jvm" ]; then
487 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
488fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800489
Alex Lighte7873ec2014-08-12 09:53:50 -0700490if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800491 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
492 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700493fi
494if [ "$gc_verify" = "true" ]; then
495 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
496fi
497if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700498 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700499fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700500if [ "$jvmti_redefine_stress" = "true" ]; then
501 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
502fi
Alex Lightc38c3692017-06-27 15:45:14 -0700503if [ "$jvmti_step_stress" = "true" ]; then
504 run_args="${run_args} --no-app-image --jvmti-step-stress"
505fi
Alex Light43e935d2017-06-19 15:40:40 -0700506if [ "$jvmti_field_stress" = "true" ]; then
507 run_args="${run_args} --no-app-image --jvmti-field-stress"
508fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700509if [ "$jvmti_trace_stress" = "true" ]; then
510 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700511fi
Jeff Hao85139a32014-07-23 11:52:52 -0700512if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700513 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
514 if [ "$trace_stream" = "true" ]; then
515 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
516 # the ability to analyze the file and just write to /dev/null.
517 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
518 # Enable streaming mode.
519 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
520 else
521 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
522 fi
523elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700524 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700525 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700526fi
527
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700528# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000529# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100530function guess_target_arch_name() {
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000531 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
532 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700533 if [ "x${suffix64}" = "x64" ]; then
534 target_arch_name=${grep64bit}
535 else
536 target_arch_name=${grep32bit}
537 fi
538}
539
David Brazdil853a4c32015-09-28 16:15:50 +0100540function guess_host_arch_name() {
541 if [ "x${suffix64}" = "x64" ]; then
542 host_arch_name="x86_64"
543 else
544 host_arch_name="x86"
545 fi
546}
547
Alex Lighta59dd802014-07-02 16:28:08 -0700548if [ "$target_mode" = "no" ]; then
549 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700550 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700551 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700552 exit 1;
553 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700554 fi
555fi
556
Alex Light03a112d2014-08-25 13:25:56 -0700557if [ "$have_patchoat" = "no" ]; then
558 run_args="${run_args} --no-patchoat"
559fi
560
561if [ "$have_dex2oat" = "no" ]; then
562 run_args="${run_args} --no-dex2oat"
563fi
564
Jeff Hao201803f2013-11-20 18:11:39 -0800565if [ ! "$runtime" = "jvm" ]; then
566 run_args="${run_args} --lib $lib"
567fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700568
Jeff Hao201803f2013-11-20 18:11:39 -0800569if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700570 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000571 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800572 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700573 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700574 else
575 true # defaults to using target BOOTCLASSPATH
576 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800577elif [ "$runtime" = "art" ]; then
578 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100579 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000580 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700581 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800582 else
David Brazdil853a4c32015-09-28 16:15:50 +0100583 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800584 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000585 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800586 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700587 if [ "$relocate" = "yes" ]; then
588 run_args="${run_args} --relocate"
589 else
590 run_args="${run_args} --no-relocate"
591 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700592elif [ "$runtime" = "jvm" ]; then
593 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800594 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700595fi
596
Alex Light03a112d2014-08-25 13:25:56 -0700597if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700598 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700599 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700600 exit 1
601 fi
Alex Light03a112d2014-08-25 13:25:56 -0700602 run_args="${run_args} --no-image"
603fi
604
jeffhao5d1ac922011-09-29 17:41:15 -0700605if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700606 err_echo "--dev and --update are mutually exclusive"
607 usage="yes"
608fi
609
610if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
611 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700612 usage="yes"
613fi
614
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700615if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
616 err_echo "--bisection-search and --prebuild are mutually exclusive"
617 usage="yes"
618fi
619
620if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
621 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
622 usage="yes"
623fi
624
625if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
626 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
627 usage="yes"
628fi
629
jeffhao5d1ac922011-09-29 17:41:15 -0700630if [ "$usage" = "no" ]; then
631 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
632 test_dir=`basename "$oldwd"`
633 else
634 test_dir="$1"
635 fi
636
637 if [ '!' -d "$test_dir" ]; then
638 td2=`echo ${test_dir}-*`
639 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700640 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700641 usage="yes"
642 fi
643 test_dir="$td2"
644 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700645 # Shift to get rid of the test name argument. The rest of the arguments
646 # will get passed to the test run.
647 shift
648fi
649
Søren Gjesse620d0a52016-09-19 11:12:51 +0200650# For building with javac and dx always use Java 7. The dx compiler
651# only support byte codes from Java 7 or earlier (class file major
652# version 51 or lower).
653if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
654 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
655fi
656
jeffhao5d1ac922011-09-29 17:41:15 -0700657if [ "$usage" = "yes" ]; then
658 prog=`basename $prog`
659 (
660 echo "usage:"
661 echo " $prog --help Print this message."
662 echo " $prog [options] [test-name] Run test normally."
663 echo " $prog --dev [options] [test-name] Development mode" \
664 "(dumps to stdout)."
665 echo " $prog --update [options] [test-name] Update mode" \
666 "(replaces expected.txt)."
667 echo ' Omitting the test name or specifying "-" will use the' \
668 "current directory."
669 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000670 echo " -O Run non-debug rather than debug build (off by default)."
671 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000672 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000673 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800674 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700675 echo " --debug Wait for the default debugger to attach."
676 echo " --debug-agent <agent-path>"
677 echo " Wait for the given debugger agent to attach. Currently"
678 echo " only supported on host."
679 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
680 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700681 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000682 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000683 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700684 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000685 echo " --build-only Build test files only (off by default)."
Alan Leung0afa07a2017-10-03 16:56:30 -0700686 echo " --build-with-d8 Build test files with javac and d8 (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200687 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
688 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000689 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800690 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000691 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000692 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700693 echo " --verify-soft-fail Force soft fail verification (off by default)."
694 echo " Verification is enabled if neither --no-verify"
695 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000696 echo " --no-optimize Turn off optimization (on by default)."
697 echo " --no-precise Turn off precise GC (on by default)."
698 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700699 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000700 echo " other runtime options are ignored."
701 echo " --no-dex2oat Run as though dex2oat was failing."
702 echo " --no-patchoat Run as though patchoat was failing."
703 echo " --prebuild Run dex2oat on the files before starting test. (default)"
704 echo " --no-prebuild Do not run dex2oat on the files before starting"
705 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700706 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000707 echo " --relocate Force the use of relocating in the test, making"
708 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000709 echo " address before running."
710 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700711 echo " --image Run the test using a precompiled boot image. (default)"
712 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000713 echo " --host Use the host-mode virtual machine."
714 echo " --invoke-with Pass --invoke-with option to runtime."
715 echo " --dalvik Use Dalvik (off by default)."
716 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700717 echo " --use-java-home Use the JAVA_HOME environment variable"
718 echo " to find the java compiler and runtime"
719 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000720 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700721 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000722 echo " --64 Run the test in 64-bit mode"
723 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700724 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700725 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000726 echo " --gcstress Run with gc stress testing"
727 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700728 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700729 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700730 echo " --jvmti-redefine-stress"
731 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000732 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700733 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000734 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000735 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700736 echo " --instruction-set-features [string]"
737 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800738 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
739 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700740 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700741 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700742 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000743 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800744 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700745 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700746 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700747 exit 1
748fi
749
750cd "$test_dir"
751test_dir=`pwd`
752
753td_info="${test_dir}/${info}"
754td_expected="${test_dir}/${expected}"
755
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700756if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700757 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700758 exit 1
759fi
760
761if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700762 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700763 exit 1
764fi
765
766# copy the test to a temp dir and run it
767
Elliott Hughes510c8782011-10-06 10:57:34 -0700768echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700769
770rm -rf "$tmp_dir"
771cp -Rp "$test_dir" "$tmp_dir"
772cd "$tmp_dir"
773
774if [ '!' -r "$build" ]; then
775 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800776else
777 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700778fi
779
780if [ '!' -r "$run" ]; then
781 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800782else
783 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700784fi
785
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700786if [ '!' -r "$check_cmd" ]; then
787 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800788else
789 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700790fi
791
jeffhao5d1ac922011-09-29 17:41:15 -0700792chmod 755 "$build"
793chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700794chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700795
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700796export TEST_NAME=`basename ${test_dir}`
797
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000798# Tests named '<number>-checker-*' will also have their CFGs verified with
799# Checker when compiled with Optimizing on host.
800if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
801 if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then
802 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
803 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
804 run_checker="yes"
805
806 if [ "$target_mode" = "no" ]; then
807 cfg_output_dir="$tmp_dir"
808 checker_args="--arch=${host_arch_name^^}"
809 else
810 cfg_output_dir="$DEX_LOCATION"
811 checker_args="--arch=${target_arch_name^^}"
812 fi
813
814 if [ "$debuggable" = "yes" ]; then
815 checker_args="$checker_args --debuggable"
816 fi
817
818 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
819 -Xcompiler-option -j1"
820 fi
821 fi
822fi
823
Mathieu Chartier031768a2015-08-27 10:25:02 -0700824 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700825
Richard Uhler020c0f32017-03-14 16:23:17 +0000826# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
827# ART output to approximately 128MB. This should be more than sufficient
828# for any test while still catching cases of runaway output.
829# Set a hard limit to encourage ART developers to increase the ulimit here if
830# needed to support a test case rather than resetting the limit in the run
831# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000832if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000833 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700834fi
835
Igor Murashkin2a337752017-06-16 14:34:40 +0000836if [[ "$target_mode" == "yes" ]]; then
837 build_args="$build_args --target"
838else
839 build_args="$build_args --host"
840fi
841
842if [[ "$dev_mode" == "yes" ]]; then
843 build_args="$build_args --dev"
844fi
845
jeffhao5d1ac922011-09-29 17:41:15 -0700846good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000847good_build="yes"
848good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700849export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700850if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000851 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700852 build_exit="$?"
853 echo "build exit status: $build_exit" 1>&2
854 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800855 echo "${test_dir}: running..." 1>&2
856 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700857 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000858
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800859 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000860 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100861 if [ "$target_mode" = "yes" ]; then
862 adb pull $cfg_output_dir/$cfg_output &> /dev/null
863 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100864 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000865 checker_exit="$?"
866 if [ "$checker_exit" = "0" ]; then
867 good="yes"
868 fi
Alex Light91de25f2015-10-28 17:00:06 -0700869 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000870 else
871 good="yes"
872 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800873 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000874 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700875 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700876elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000877 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700878 build_exit="$?"
879 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800880 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700881 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000882 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100883 if [ "$target_mode" = "yes" ]; then
884 adb pull $cfg_output_dir/$cfg_output &> /dev/null
885 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100886 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000887 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700888 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
889 good="yes"
890 else
Alex Light91de25f2015-10-28 17:00:06 -0700891 cat "$build_output" 1>&${real_stderr} 1>&2
892 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700893 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700894elif [ "$build_only" = "yes" ]; then
895 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000896 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700897 build_exit="$?"
898 if [ "$build_exit" '!=' '0' ]; then
899 cp "$build_output" "$output"
900 echo "build exit status: $build_exit" >>"$output"
901 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
902 if [ "$?" '!=' "0" ]; then
903 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700904 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700905 fi
906 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700907 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700908 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700909 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700910else
David Brazdil4846d132015-01-15 19:07:08 +0000911 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700912 build_exit="$?"
913 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800914 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700915 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000916 run_exit="$?"
917 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700918 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000919 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000920 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100921 if [ "$target_mode" = "yes" ]; then
922 adb pull $cfg_output_dir/$cfg_output &> /dev/null
923 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100924 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000925 checker_exit="$?"
926 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700927 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000928 good_run="no"
929 else
930 good_run="yes"
931 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000932 else
933 good_run="yes"
934 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700935 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000936 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700937 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700938 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
939 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700940 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700941 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700942 max_name_length=$(getconf NAME_MAX ${tmp_dir})
943 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
944 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700945 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700946 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700947 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700948 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000949 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
950 # output == expected
951 good="yes"
952 echo "${test_dir}: succeeded!" 1>&2
953 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700954 fi
955fi
956
jeffhao5d1ac922011-09-29 17:41:15 -0700957(
Alex Lightbfac14a2014-07-30 09:41:21 -0700958 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700959 echo "${test_dir}: FAILED!"
960 echo ' '
961 echo '#################### info'
962 cat "${td_info}" | sed 's/^/# /g'
963 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700964 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700965 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700966 if [ "$strace" = "yes" ]; then
967 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700968 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700969 echo '####################'
970 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700971 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
972 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
973 # tools used by the given ABI work for both x86 and x86-64.
974 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
975 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700976 echo ' '
977 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700978
Alex Light91de25f2015-10-28 17:00:06 -0700979) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700980
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700981# Attempt bisection only if the test failed.
982if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
983 # Bisecting works by skipping different optimization passes which breaks checker assertions.
984 if [ "$run_checker" == "yes" ]; then
985 echo "${test_dir}: not bisecting, checker test." 1>&2
986 else
987 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700988 echo "${test_dir}: bisecting..." 1>&2
989 cwd=`pwd`
990 maybe_device_mode=""
991 raw_cmd=""
992 if [ "$target_mode" = "yes" ]; then
993 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
994 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
995 # to exec in order to preserve pid when calling dalvikvm. This is required
996 # for bisection search to correctly retrieve logs from device.
997 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
998 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
999 maybe_device_mode="--device"
1000 raw_cmd="$DEX_LOCATION/cmdline.sh"
1001 else
1002 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
1003 fi
1004 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1005 $maybe_device_mode \
1006 --raw-cmd="$raw_cmd" \
1007 --check-script="$cwd/check" \
1008 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001009 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001010 --timeout=300
1011 fi
1012fi
1013
Alex Lightbfac14a2014-07-30 09:41:21 -07001014# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001015if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001016 cd "$oldwd"
1017 rm -rf "$tmp_dir"
1018 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
1019 adb shell rm -rf $DEX_LOCATION
1020 fi
1021 if [ "$good" = "yes" ]; then
1022 exit 0
1023 fi
1024fi
1025
1026
1027(
1028 if [ "$always_clean" = "yes" ]; then
1029 echo "${TEST_NAME} files deleted from host "
1030 if [ "$target_mode" == "yes" ]; then
1031 echo "and from target"
1032 fi
1033 else
1034 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1035 if [ "$target_mode" == "yes" ]; then
1036 echo "and in ${DEX_LOCATION} on target"
1037 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001038 fi
1039
Alex Light91de25f2015-10-28 17:00:06 -07001040) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001041
Alex Light6a870fa2016-05-31 16:36:19 -07001042if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1043 exit 0
1044else
1045 exit 1
1046fi